//+------------------------------------------------------------------+
//|                                                  KurkaTrader.mq4 |
//|                                     Copyright  2006, KurkaFund. |
//|                                         http://www.kurkafund.com |
//|                                     Code Modifications by Tururo |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, KurkaFund."
#property link      "http://www.kurkafund.com"
#include <stdlib.mqh>

//---- input parameters
//trading parameters
extern int    MagicNumber  = 1234567;
extern double Risk         = 0.2;              //percentage of AccountFreeMargin used to open position
extern double TrailingStop = 20;
extern double StopMinMove  = 20;

extern double TakeProfitLow = 10;
extern double StopLossLow   = 20;
extern double TakeProfitMid = 20;
extern double StopLossMid   = 30;
extern double TakeProfitHigh= 30;
extern double StopLossHigh  = 40;

extern double SignalCandle = 1;

extern bool   TradeLowTrends   = true;
extern bool   TradeMidTrends   = true;
extern bool   TradeHighTrends  = true;

extern bool   UseOSMA          = true;
extern int    OSMAFast         = 5;
extern int    OSMASlow         = 30;
extern double OSMASignal       = 2;

extern bool   UseCCI           = true;
extern int    CCIPrice         = 0;    // 0 = Close price; 1 = Open price; 2 = High price; 3 = Low price; 4 = Median price, 5 = Typical price; 6 = Weighted close price
extern int    CciPer           = 18;
extern int    Cci_Level1       = 50;
extern int    Cci_Level2       = 100;
extern int    Cci_Level3       = 150;

extern bool   UseStoch         = true;
extern double StochHigh        = 75;
extern double StochLow         = 25;

extern bool   UseSar           = true;
extern double SarStep          = 0.02;
extern double SarMax           = 0.2;

extern bool   UseHighLow       = true;
extern int    HighPeriods      = 4;
extern int    HighPips         = 3;
extern int    HighStep         = 2;

extern bool   UseTrend         = true;
extern int    MAPeriod         = PERIOD_H1;
extern int    MAMode           = 2;    // 0 = simple; 1 = Exponential; 2 = Smoothed; 3 = linear weighted;
extern int    MAPrice          = 0;    // 0 = Close price; 1 = Open price; 2 = High price; 3 = Low price; 4 = Median price, 5 = Typical price; 6 = Weighted close price
extern double Trend_Strength_1 = 0.25; //Multiplies Lots for entry based on sum of true trend strength. 
extern double Trend_Strength_2 = 0.25;
extern double Trend_Strength_3 = 0.5;
extern double Trend_Strength_4 = 0.5;
extern double Trend_Strength_5 = 1;
extern double Trend_Strength_6 = 1;
extern int    Ema_1            = 8;
extern int    Ema_2            = 24;
extern int    Ema_3            = 72;
extern int    Ema_4            = 216;
extern int    EmaShift         = 0;

extern int    Slippage         = 3;
int close_position()
{
   int i, cnt = OrdersTotal();
   for (i=0; i<cnt; i++) {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) {
         if (OrderType() == OP_SELL) {
           OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Red);
         }
         else if (OrderType() == OP_BUY) {
           OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Green);
         }
      }
   }
}

int start()
{
  if(Bars<Ema_4)
  {
    Print("Not Enough Bars");
    return(0); 
  } 
 

  if (UseTrend){
    //Trend EMA's
    double Ema1 = iMA(NULL,MAPeriod,Ema_1, 0, MAMode, MAPrice, SignalCandle);
    double Ema2 = iMA(NULL,MAPeriod,Ema_2, 0, MAMode, MAPrice, SignalCandle);
    double Ema3 = iMA(NULL,MAPeriod,Ema_3, 0, MAMode, MAPrice, SignalCandle);
    double Ema4 = iMA(NULL,MAPeriod,Ema_4, 0, MAMode, MAPrice, SignalCandle);

    //Up Trend Calcs

    double up1 = 0, up2 = 0, up3 = 0, up4 = 0, up5 = 0, up6 = 0;

    if (Ema1 > Ema2){ 
      up1 = Trend_Strength_1; 
    }
    if ((Ema1 > Ema2) && (Ema1 > Ema3)){
      up2 = Trend_Strength_2; 
    }
    if ((Ema1 > Ema2) && (Ema1 > Ema3) && (Ema1 > Ema4)){
      up3 = Trend_Strength_3;
    }
    if ((Ema1 > Ema2) && (Ema1 > Ema3) && (Ema1 > Ema4) && (Ema2 > Ema3)){
      up4 = Trend_Strength_4;
    }
    if ((Ema1 > Ema2) && (Ema1 > Ema3) && (Ema1 > Ema4) && (Ema2 > Ema3) && (Ema2 > Ema4)){
       up5 = Trend_Strength_5;
    }
    if ((Ema1 > Ema2) && (Ema1 > Ema3) && (Ema1 > Ema4) && (Ema2 > Ema3) && (Ema2 > Ema4) && (Ema3 > Ema4)){
       up6 = Trend_Strength_6; 
    }

    //Down Trend Calcs
    double dn1 = 0, dn2 = 0, dn3 = 0, dn4 = 0, dn5 = 0, dn6 = 0;

    if (Ema1 < Ema2){
      dn1 = Trend_Strength_1;
      Print("DOWN ", dn1);
    } 
    if ((Ema1 < Ema2) && (Ema1 < Ema3)){
      dn2 = Trend_Strength_2; 
    }
    if ((Ema1 < Ema2) && (Ema1 < Ema3) && (Ema1 < Ema4)){
      dn3 = Trend_Strength_3; 
    }
    if ((Ema1 < Ema2) && (Ema1 < Ema3) && (Ema1 < Ema4) && (Ema2 < Ema3)){
      dn4 = Trend_Strength_4; 
    }
    if ((Ema1 < Ema2) && (Ema1 < Ema3) && (Ema1 < Ema4) && (Ema2 < Ema3) && (Ema2 < Ema4)){
      dn5 = Trend_Strength_5;
    } 
    if ((Ema1 < Ema2) && (Ema1 < Ema3) && (Ema1 < Ema4) && (Ema2 < Ema3) && (Ema2 < Ema4) && (Ema3 < Ema4)){
       dn6 = Trend_Strength_6;
    } 


}
//===================== Signals ==========================

//====================== OSMA ===========================
 bool OSMABUY  = false;
 bool OSMASELL = false;
 bool OSMAUP   = false;
 bool OSMADOWN = false;

if (UseOSMA){
            double OSMAPrev=iOsMA(NULL,0,OSMASlow,OSMAFast,OSMASignal,PRICE_CLOSE,SignalCandle+1);
            double OSMA=iOsMA(NULL,0,OSMASlow,OSMAFast,OSMASignal,PRICE_CLOSE,SignalCandle);
            
            if (OSMA > OSMAPrev) {OSMABUY = true;}
            if (OSMA < OSMAPrev) {OSMASELL = true;}
            if (OSMA > 0)        {OSMAUP = true;}
            if (OSMA < 0)        {OSMADOWN = true;}
            }
else {
  OSMABUY  = true;
  OSMASELL = true;
  OSMAUP   = true;
  OSMADOWN = true;
}
 
//====================== CCI ===========================

bool CCIBUY  = false;
bool CCISELL = false;
bool CCIUP   = false;
bool CCIDOWN = false; 

if (UseCCI){
            double CCI          = iCCI(NULL,0,CciPer,CCIPrice,SignalCandle);
            double CCIPrevious  = iCCI(NULL,0,CciPer,CCIPrice,SignalCandle+1);
                  
            if (CCI > Cci_Level1 && CCIPrevious <= Cci_Level1)    {CCIBUY  = true;}
            if (CCI > Cci_Level2 && CCIPrevious <= Cci_Level2)    {CCIBUY  = true;}
            if (CCI > Cci_Level3 && CCIPrevious <= Cci_Level3)    {CCIBUY  = true;}
            if (CCI < Cci_Level1 && CCIPrevious >= (-Cci_Level1)) {CCISELL = true;}
            if (CCI < Cci_Level2 && CCIPrevious >= (-Cci_Level2)) {CCISELL = true;}
            if (CCI < Cci_Level3 && CCIPrevious >= (-Cci_Level3)) {CCISELL = true;}
            }
else{
  CCIBUY  = true;
  CCISELL = true;
  CCIUP   = true;
  CCIDOWN = true;
}
//====================== Stoch ===========================

bool STOCHBUY  = false;
bool STOCHSELL = false;
bool STOCHUP   = false;
bool STOCHDOWN = false;

if (UseStoch){
              double Stoc            = iCustom(NULL, 0, "Zerolagstochs", 0,SignalCandle);
              double StocSignal      = iCustom(NULL, 0, "Zerolagstochs", 1,SignalCandle);
              double StocPrev        = iCustom(NULL, 0, "Zerolagstochs", 0,SignalCandle+1);  
              double StocPrevSignal  = iCustom(NULL, 0, "Zerolagstochs", 1,SignalCandle+1);
            
              if (Stoc > StocSignal && StocPrev <= StocPrevSignal && Stoc < StochLow)  {STOCHBUY  = true;}
              if (Stoc < StocSignal && StocPrev >= StocPrevSignal && Stoc > StochHigh) {STOCHSELL = true;}
              if (Stoc > StocSignal)                                                   {STOCHUP   = true;}
              if (Stoc < StocSignal)                                                   {STOCHDOWN = true;}
              }

else{
  STOCHBUY  = true;
  STOCHSELL = true;
  STOCHUP   = true;
  STOCHDOWN = true;
}

//========================= SAR ==========================================

bool SARBUY  = false;
bool SARSELL = false;
bool SARUP   = false;
bool SARDOWN = false;

if (UseSar){
             double SarCurrent    = iSAR(NULL, 0, SarStep, SarMax, SignalCandle);
             double SarPrevious   = iSAR(NULL, 0, SarStep, SarMax, SignalCandle+1);
             
             if (SarCurrent <= Ask && SarPrevious>SarCurrent) {SARBUY  = true;}
             if (SarCurrent >= Bid && SarPrevious<SarCurrent) {SARSELL = true;}
             if (SarCurrent <= Ask)                           {SARBUY  = true;}
             if (SarCurrent >= Bid)                           {SARSELL = true;}
             }
             
else{
  SARBUY  = true;
  SARSELL = true;
  SARUP   = true;
  SARDOWN = true;           
}


 /* /============================== High Low ====================================
 bool HIGHBUY  = false;
 bool HIGHSTEP = false;
 bool LOWBUY   = false;
 
 if(UseHighLow){
            double HighPoint    = iHigh(NULL,0,SignalCandle)
            int    HighestPoint = Highest(NULL,0,2,HighPeriods,SignalCandle
            double HighCurrent  = iHigh(NULL,0,0)
            
            
            
            double LowPoint  = iLow(NULL,0,SignalCandle)
            double HighBuy   = iHigh(NULL,0,0)
            double LowBuy    = iLow(NULL,0,0)
          
            if (HighCurrent <=(HighPoint - HighPips)) {HIGHBUY = true; HIGHSTEP=true;}
            if (HIGHSTEP){
              if (HighCurrent <= HighPoint - HighPips - HighStep) 
            
            
            if (LowBuy >= (Lowpoint + LowPips))   {LOWBUY  = true;}
 
 
*/

  int buy_orders = 0, sell_orders = 0;
  int i;
  int cnt = OrdersTotal();
  for (i=0;i<cnt;i++) {
    OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
    if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
      if (OrderType() == OP_BUY) buy_orders++;
      else if (OrderType() == OP_SELL) sell_orders++;
  }
//Long Positions
double Up_Trend_Score = (up1 + up2 + up3 + up4 + up5 + up6);
if (UseTrend==false){Up_Trend_Score = 1;}
double minlots = MarketInfo(Symbol(), MODE_MINLOT);
double lotstep = MarketInfo(Symbol(), MODE_LOTSTEP);
double LongLots = (AccountFreeMargin()* AccountLeverage()* Up_Trend_Score / MarketInfo(Symbol(), MODE_LOTSIZE)) * Risk/100.0;
if (LongLots < minlots) LongLots = minlots;
LongLots /= lotstep;
LongLots = NormalizeDouble(LongLots, 0);
LongLots *= lotstep;


if (TradeLowTrends){
  if ((up1 > 0 || up2 > 0) && up3 + up4 + up5 + up6 == 0 && buy_orders < 1){
    if (STOCHBUY == true && OSMAUP == true && OSMABUY == true && SARBUY == true){
      if (sell_orders > 0) close_position();
      OrderSend(Symbol(),OP_BUY,LongLots,Ask,3,Ask-StopLossLow*Point,Ask+TakeProfitLow*Point,"Go Long Low Trend",MagicNumber,0,Green);
      return(0);
      }
     }
    } 
if (TradeMidTrends){
  if ((up3 > 0 || up4 > 0) && up5 + up6 == 0 && buy_orders < 2){
    if (CCIBUY == true && OSMABUY == true){
      if (sell_orders > 0) close_position();
      OrderSend(Symbol(),OP_BUY,LongLots,Ask,3,Ask-StopLossMid*Point,Ask+TakeProfitMid*Point,"Go Long Mid Trend",MagicNumber,0,Green);
      return(0);
      }
     }
    }
if (TradeHighTrends){
  if (up5 > 0 || up6 > 0 && buy_orders < 5){
    if ((OSMAUP == true && OSMABUY == true)||(CCIBUY == true && OSMABUY == true)||(STOCHBUY == true && OSMAUP == true)||
       (SARBUY  == true)){
      if (sell_orders > 0) close_position();
       OrderSend(Symbol(),OP_BUY,LongLots,Ask,3,Ask-StopLossHigh*Point,Ask+TakeProfitHigh*Point,"Go Long High Trend",MagicNumber,0,Green);
       return(0);
       }
      }
     }
//Short Positions 
 
double Down_Trend_Score = (dn1 + dn2 + dn3 + dn4 + dn5 + dn6);
if (UseTrend==false){Down_Trend_Score = 1;}
double ShortLots = (AccountFreeMargin()* AccountLeverage()*Down_Trend_Score / MarketInfo(Symbol(), MODE_LOTSIZE)) * Risk/100.0;
if (ShortLots < minlots) ShortLots = minlots;
ShortLots /= lotstep;
ShortLots = NormalizeDouble(ShortLots, 0);
ShortLots *= lotstep;

if (Down_Trend_Score>0)Print("Up Trend Score=", Up_Trend_Score, " Down=",Down_Trend_Score);
if (TradeLowTrends){
  if ((dn1 > 0 || dn2 > 0) && dn3 + dn4 + dn5 + dn6 == 0 && sell_orders < 1 ){
    if (STOCHSELL == true && OSMADOWN == true && OSMASELL == true && SARSELL == true){
      Print("Selling");
      if (buy_orders > 0) close_position();
      OrderSend(Symbol(),OP_SELL,ShortLots,Bid,3,Bid+StopLossLow*Point,Bid-TakeProfitLow*Point,"Go Short Low Trend",MagicNumber,0,Green);
      return(0);
      }
     }
    }  
if (TradeMidTrends){
  if ((dn3 > 0 || dn4 > 0) && dn5 + dn6 == 0 && sell_orders < 2){
    if (CCISELL == true && OSMASELL == true){
      Print("Selling");
      if (buy_orders > 0) close_position();
      OrderSend(Symbol(),OP_SELL,ShortLots,Bid,3,Bid+StopLossMid*Point,Bid-TakeProfitMid*Point,"Go Short Mid Trend",MagicNumber,0,Green);
      return(0);
      }
     }
    }  
if (TradeHighTrends){  
  if (dn5 > 0 || dn6 > 0  && sell_orders < 5){
    if ((OSMADOWN == true && OSMASELL == true)||(CCISELL == true && OSMASELL == true)||(STOCHSELL == true && OSMADOWN == true)||
       (SARSELL  == true)){
      Print("Selling");
      if (buy_orders > 0) close_position();
       OrderSend(Symbol(),OP_SELL,ShortLots,Bid,3,Bid+StopLossHigh*Point,Bid-TakeProfitHigh*Point,"Go Short Mid Trend",MagicNumber,0,Green);
       return(0);
       }
      }
     }


      // implement trailing stop
      if(TrailingStop>0)   {
         int currentOrders = OrdersTotal();
         for(i=0;i<currentOrders;i++){
            OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
            if(OrderType()==OP_BUY && OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) {
               // long position is opened
               if(Bid-OrderOpenPrice()>Point*StopMinMove)
                 {
                  if(OrderStopLoss()<Bid-Point*TrailingStop)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                    }
                 }
            }
             else if (OrderType()==OP_SELL && OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) {
                 if((OrderOpenPrice()-Ask)>(Point*StopMinMove))
                 {
                  if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
                    }
                 }
             }
          }
      }

return(0);
}